---
title: sql
type: processor
status: deprecated
categories: ["Integration"]
---

<!--
     THIS FILE IS AUTOGENERATED!

     To make changes please edit the contents of:
     lib/processor/sql.go
-->

import Tabs from '@theme/Tabs';
import TabItem from '@theme/TabItem';

:::warning DEPRECATED
This component is deprecated and will be removed in the next major version release. Please consider moving onto [alternative components](#alternatives).
:::
Runs an arbitrary SQL query against a database and (optionally) returns the result as an array of objects, one for each row returned.

Introduced in version 3.65.0.


<Tabs defaultValue="common" values={[
  { label: 'Common', value: 'common', },
  { label: 'Advanced', value: 'advanced', },
]}>

<TabItem value="common">

```yml
# Common config fields, showing default values
label: ""
sql:
  driver: ""
  data_source_name: ""
  query: ""
  args_mapping: ""
  result_codec: none
```

</TabItem>
<TabItem value="advanced">

```yml
# All config fields, showing default values
label: ""
sql:
  driver: ""
  data_source_name: ""
  query: ""
  unsafe_dynamic_query: false
  args_mapping: ""
  result_codec: none
```

</TabItem>
</Tabs>

If the query fails to execute then the message will remain unchanged and the error can be caught using error handling methods outlined [here](/docs/configuration/error_handling).

## Alternatives

For basic inserts or select queries use use either the [`sql_insert`](/docs/components/processors/sql_insert) or the [`sql_select`](/docs/components/processors/sql_select) processor. For more complex queries use the [`sql_raw`](/docs/components/processors/sql_raw) processor.

## Fields

### `driver`

A database [driver](#drivers) to use.


Type: `string`  
Options: `mysql`, `postgres`, `clickhouse`, `mssql`.

### `data_source_name`

Sorry! This field is missing documentation.


Type: `string`  

### `query`

The query to execute. The style of placeholder to use depends on the driver, some drivers require question marks (`?`) whereas others expect incrementing dollar signs (`$1`, `$2`, and so on). The style to use is outlined in this table:

| Driver | Placeholder Style |
|---|---|
| `clickhouse` | Dollar sign |
| `mysql` | Question mark |
| `postgres` | Dollar sign |
| `mssql` | Question mark |


Type: `string`  

```yml
# Examples

query: INSERT INTO footable (foo, bar, baz) VALUES (?, ?, ?);
```

### `unsafe_dynamic_query`

Whether to enable [interpolation functions](/docs/configuration/interpolation/#bloblang-queries) in the query. Great care should be made to ensure your queries are defended against injection attacks.


Type: `bool`  
Default: `false`  

### `args_mapping`

An optional [Bloblang mapping](/docs/guides/bloblang/about) which should evaluate to an array of values matching in size to the number of placeholder arguments in the field `query`.


Type: `string`  

```yml
# Examples

args_mapping: root = [ this.cat.meow, this.doc.woofs[0] ]

args_mapping: root = [ meta("user.id") ]
```

### `result_codec`

Sorry! This field is missing documentation.


Type: `string`  
Default: `"none"`  


